
/**	@file	dk3inst.h	Get installation directory names.
 */

#ifndef DK3_INST_H_INCLUDED
#define DK3_INST_H_INCLUDED 1


#ifdef __cplusplus
extern "C" {
#endif

/**	Retrieve one directory name.
* 	@param	i	Index of directory in array.
* 	0=prefix (i.e. /usr), 1=system configuration directory
* 	(i.e. /etc), 2=data root directory (i.e. /usr/share),
* 	3=local state directory (i.e. /var), 4=binaries directory
* 	(i.e. /usr/bin), 5=administrators binaries directory
* 	(i.e. /usr/sbin), 6=library directory (i.e. /usr/lib),
* 	7=include directory (i.e. /usr/include), 8=manual directory
* 	(i.e. /usr/man), 9=..., 10=libexec directory (i.e. /usr/libexec).
* 	@return	The directory name on success, NULL on error.
*/
/*^null^*/
/*^dependent^*/
dkChar const *
dk3inst_get_directory(size_t i) /*^*/ ;

#ifdef __cplusplus
}
#endif

#endif

