/*
	WARNING: This file was generated by dkct.
	Changes you make here will be lost if dkct is run again!
	You should modify the original source and run dkct on it.
	Original source: dk3paper.ctr
*/

/*
Copyright (C) 2011-2014, Dirk Krause

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above opyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
* Neither the name of the author nor the names of contributors may be used
  to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/**	@file */

#ifndef DK3PAPER_H_INCLUDED
/** Avoid multiple inclusions. */
#define DK3PAPER_H_INCLUDED 1


#line 10 "dk3paper.ctr"

#ifdef __cplusplus
extern "C" {
#endif

/**	Create paper sizes collection, read dk3paper.conf files.
	@param	app	Application structure for diagnostics and file search,
			must not be NULL.
	@return	Pointer to new collection on success, NULL on error.
*/
dk3_paper_size_collection_t *
dk3paper_open_app(dk3_app_t *app);

/**	Find paper size by name.
	@param	psc	Paper size collection.
	@param	psn	Paper size name.
	@return	Pointer to paper size on success, NULL on error.
*/
dk3_paper_size_t const *
dk3paper_find(dk3_paper_size_collection_t *psc, dkChar const *psn);

/**	Close paper size collection, release memory.
	@param	psc	Collection to close.
*/
void
dk3paper_close(dk3_paper_size_collection_t *psc);

/**	Prepare traversing the paper size collection for named paper sizes.
	@param	psc	Paper size collection.
*/
void
dk3paper_reset(dk3_paper_size_collection_t *psc);

/**	Retrieve next named paper size from size collection.
	@param	psc	Paper size collection.
	@return	Pointer to named paper size on success, NULL on error/end.
*/
dk3_named_paper_size_t const *
dk3paper_next(dk3_paper_size_collection_t *psc);

#ifdef __cplusplus
}
#endif




#endif
